﻿using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ef6TestApp
{
    public class ShopContext : DbContext
    {
        public DbSet<Order>? Products { get; set; }
        public DbSet<Order>? Orders { get; set; }

        public ShopContext()
        {
        }


        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            optionsBuilder.UseSqlServer("Data Source=(local);Initial Catalog=test;Integrated Security=True");
            optionsBuilder.LogTo(m => Debug.WriteLine(m));
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<Order>(b =>
            {
                b.ToTable(ot => ot.IsTemporal());
                b.Property(x => x.ChangedOn).HasComputedColumnSql("[PeriodStart]");
            });

            modelBuilder.Entity<Product>(b =>
            {
                b.ToTable(ot => ot.IsTemporal());
            });
        }

    }
}
